Main Page | Namespace List | Class Hierarchy | Alphabetical List | Compound List | File List | Namespace Members | Compound Members | File Members

# ASN1Key Class Reference

`#include <asn.h>`

Inheritance diagram for ASN1Key:

List of all members.

## Detailed Description

Definition at line 230 of file asn.h.

## Public Member Functions
virtual OID | GetAlgorithmID () const=0
virtual bool | BERDecodeAlgorithmParameters (BufferedTransformation &bt)
virtual bool | DEREncodeAlgorithmParameters (BufferedTransformation &bt) const
virtual void | BERDecodeKey (BufferedTransformation &bt)
virtual void | BERDecodeKey2 (BufferedTransformation &bt, bool parametersPresent, unsigned int size)
virtual void | DEREncodeKey (BufferedTransformation &bt) const=0
void | Save (BufferedTransformation &bt) const
| save key into a BufferedTransformation
void | Load (BufferedTransformation &bt)
| load key from a BufferedTransformation
virtual void | BERDecode (BufferedTransformation &bt)=0
| decode this object from a BufferedTransformation, using BER (Basic Encoding Rules)
virtual void | DEREncode (BufferedTransformation &bt) const=0
| encode this object into a BufferedTransformation, using DER (Distinguished Encoding Rules)
virtual void | BEREncode (BufferedTransformation &bt) const
| encode this object into a BufferedTransformation, using BER
virtual void | AssignFrom (const NameValuePairs &source)=0
| assign values from source to this object
virtual bool | Validate (RandomNumberGenerator &rng, unsigned int level) const=0
| check this object for errors
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| throws InvalidMaterial if this object fails Validate() test
virtual bool | SupportsPrecomputation () const
| Returns: whether this object supports precomputation
virtual void | Precompute (unsigned int n)
| do precomputation
virtual void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| retrieve previously saved precomputation
virtual void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| save precomputation for later use
void | DoQuickSanityCheck () const
template<class T> bool | GetThisObject (T &object) const
| get a copy of this object or a subobject of it
template<class T> bool | GetThisPointer (T *&p) const
| get a pointer to this object, as a pointer to T
template<class T> bool | GetValue (const char *name, T &value) const
| get a named value, returns true if the name exists
template<class T> T | GetValueWithDefault (const char *name, T defaultValue) const
| get a named value, returns the default if the name doesn't exist
std::string | GetValueNames () const
| get a list of value names that can be retrieved
bool | GetIntValue (const char *name, int &value) const
| get a named value with type int
int | GetIntValueWithDefault (const char *name, int defaultValue) const
| get a named value with type int, with default
template<class T> void | GetRequiredParameter (const char *className, const char *name, T &value) const
void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
virtual bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const=0
| to be implemented by derived classes, users should use one of the above functions instead
## Static Public Member Functions
void | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| used by derived classes to check for type mismatch

## Member Function Documentation

void ASN1CryptoMaterial::Load | ( | BufferedTransformation & | bt | ) | `[inline, virtual, inherited]`

  | load key from a BufferedTransformation Exceptions:
  KeyingErr | if decode fails
Note: Generally does not check that the key is valid. Call ValidateKey() or ThrowIfInvalidKey() to check that. Reimplemented from CryptoMaterial. Definition at line 49 of file simple.h. References ASN1Object::BERDecode().

virtual void ASN1Object::BEREncode | ( | BufferedTransformation & | bt | ) | const`[inline, virtual, inherited]`

| encode this object into a BufferedTransformation, using BER this may be useful if DEREncode() would be too inefficient Definition at line 1582 of file cryptlib.h. Referenced by ASN1CryptoMaterial::Save().

virtual void CryptoMaterial::AssignFrom | ( | const NameValuePairs & | source | ) | `[pure virtual, inherited]`

| assign values from source to this object Note: This function can be used to create a public key from a private key. Implemented in DL_GroupParameters_EC< EC >, ESIGNFunction, InvertibleESIGNFunction, DL_GroupParameters_IntegerBased, DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >, LUCFunction, InvertibleLUCFunction, RabinFunction, InvertibleRabinFunction, RSAFunction, InvertibleRSAFunction, RWFunction< r >, InvertibleRWFunction< r >, XTR_DH, DL_GroupParameters_IntegerBasedImpl< DL_GroupPrecomputation_LUC, DL_BasePrecomputation_LUC >, and DL_GroupParameters_IntegerBasedImpl< ModExpPrecomputation >.

virtual bool CryptoMaterial::Validate | ( | RandomNumberGenerator & | rng,
|  | unsigned int | level
| ) | const`[pure virtual, inherited]`

  | check this object for errors Parameters:
  level | denotes the level of thoroughness: 0 - using this object won't cause a crash or exception (rng is ignored) 1 - this object will probably function (encrypt, sign, etc.) correctly (but may not check for weak keys and such) 2 - make sure this object will function correctly, and do reasonable security checks 3 - do checks that may take a long time
Returns: true if the tests pass Implemented in ESIGNFunction, InvertibleESIGNFunction, LUCFunction, InvertibleLUCFunction, DL_GroupParameters< T >, DL_PrivateKeyImpl< GP >, DL_PublicKeyImpl< GP >, RabinFunction, InvertibleRabinFunction, RSAFunction, InvertibleRSAFunction, RWFunction< r >, InvertibleRWFunction< r >, XTR_DH, DL_GroupParameters< Integer >, DL_GroupParameters< typenameEcPrecomputation< EC >::Element >, DL_PrivateKeyImpl< DL_GroupParameters_EC< EC > >, and DL_PublicKeyImpl< DL_GroupParameters_EC< EC > >.

virtual void CryptoMaterial::Precompute | ( | unsigned int | n | ) | `[inline, virtual, inherited]`

| do precomputation The exact semantics of Precompute() is varies, but typically it means calculate a table of n objects that can be used later to speed up computation. Reimplemented in DL_GroupParameters< T >, DL_PrivateKeyImpl< GP >, DL_PublicKeyImpl< GP >, DL_GroupParameters< Integer >, DL_GroupParameters< typenameEcPrecomputation< EC >::Element >, DL_PrivateKeyImpl< DL_GroupParameters_EC< EC > >, and DL_PublicKeyImpl< DL_GroupParameters_EC< EC > >. Definition at line 995 of file cryptlib.h.

bool NameValuePairs::GetIntValue | ( | const char * | name,
|  | int & | value
| ) | const`[inline, inherited]`

| get a named value with type int used to ensure we don't accidentally try to get an unsigned int or some other type when we mean int (which is the most common case) Definition at line 275 of file cryptlib.h. References NameValuePairs::GetValue(). Referenced by InvertibleRWFunction< r >::GenerateRandom(), InvertibleRSAFunction::GenerateRandom(), InvertibleRabinFunction::GenerateRandom(), InvertibleLUCFunction::GenerateRandom(), DL_GroupParameters_IntegerBased::GenerateRandom(), DL_GroupParameters_DSA::GenerateRandom(), and InvertibleESIGNFunction::GenerateRandom().

The documentation for this class was generated from the following file:

- asn.h